clear
% Ce fichier initialise la simulation SCAOQTN7.m

altitude=470;  % en km
rayon_orbital=(6378+altitude)*1000;

rotation_orbitale=(39.86e4/(6378+altitude)^3)^0.5;
inclinaison=97.19*pi/180;
 COUPLE_AERO=3.7e-5;

% Inerties
Ir=132;
It=137;
Il=7;

% Initialisation en vitesses angulaires absolues (rd/s)

v_roulis0=0.000;
v_tangage0=-0.005;
v_lacet0=0;

% Initialisation en position (rd)

roulis0=0.00;
tangage0=-0.00;
lacet0=0.0;

% Calcul du champ magntique terrestre
disp('***********************************************************');
disp('');
disp('    Conseil:donnez un temps d''au moins une periode');
disp('');

tsim=input('          Temps de simulation (s) : ');

disp('');
disp('***********************************************************');
disp('');
disp('   On vous demande le nombre de points de memorisation  de Matlab ');
disp('      pour le trace des courbes des variables de sortie');
disp('');
disp('   Conseil :ce nombre doit etre superieur au nombre de pas');
disp('            de la simulation');

points_trace=input('    Nombre points memorisation trace des courbes : ');



% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    rotation_orbitale*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    rotation_orbitale*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    rotation_orbitale*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe  la base satellite
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

if (1+trac)>0,
	qt00=(1+trac)^0.5/2;
else 
	qt00=0;
end

if (1-trac+2*Pmat(1,1))>0,
	qt10=(1-trac+2*Pmat(1,1))^0.5/2;
else
	qt10=0;
end

if (1-trac+2*Pmat(2,2))>0, 
	qt20=(1-trac+2*Pmat(2,2))^0.5/2;
else
	qt20=0;
end

if (1-trac+2*Pmat(3,3))>0,
	qt30=(1-trac+2*Pmat(3,3))^0.5/2;
else
	qt30=0;
end

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((Pmat(2,1)-Pmat(1,2))/4/qt00);

elseif abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);

elseif abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);

elseif abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((Pmat(2,1)-Pmat(1,2))/4/qt30);

end

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 qt00 qt10 qt20 qt30];

end








