% VISUALISATION DES ANGLES DE ROULIS LACET ET TANGAGE D'UN 
% SATELLITE ETUDIE PAR LES QUATERNIONS (valeurs relles)

% Rcupration du quaternion

Q=solution(:,4:7);

% Initialisation des variables du trac

var_temps=[temps(1)];
var_roulis=[roulis0];
var_tangage=[tangage0];
var_lacet=[lacet0];

memoire=[];

n=length(temps);

Q0=Q(1,1);Q1=Q(1,2);Q2=Q(1,3);Q3=Q(1,4);
x_3d=[2*(Q1*Q3+Q0*Q2)];
y_3d=[2*(Q3*Q2-Q0*Q1)];
z_3d=[2*(Q0^2+Q3^2)-1];

for k=2:n,

  Q0=Q(k,1);Q1=Q(k,2);Q2=Q(k,3);Q3=Q(k,4);
  P31=2*(Q1*Q3-Q0*Q2);
  P33=2*(Q0^2+Q3^2)-1;
  P11=2*(Q0^2+Q1^2)-1;
  P21=2*(Q1*Q2+Q0*Q3);
  P32=2*(Q2*Q3+Q0*Q1);

x_3d=[x_3d 2*(Q1*Q3+Q0*Q2)];
y_3d=[y_3d 2*(Q3*Q2-Q0*Q1)];
z_3d=[z_3d 2*(Q0^2+Q3^2)-1];


    if abs(P31)<0.9999,

	% CALCUL ROULIS
	var_roulis=[var_roulis atan(P32/P33)];
				
	% CALCUL LACET
	var_lacet=[var_lacet atan(P21/P11)];

	% CALCUL TANGAGE
	if abs(sin(var_roulis(length(var_roulis))))>0.001
		var_tangage=[var_tangage atan(-P31*sin(var_roulis(length(var_roulis)))/P32)];
	else
		var_tangage=[var_tangage atan(-P31*cos(var_roulis(length(var_roulis)))/P33)];
	end
	% MEMORISATION DU TEMPS
	var_temps=[var_temps temps(k)];
    end
end

figure(1)
subplot(2,2,1);
plot(var_temps,180/pi*var_roulis,'r');
title('ROULIS (en degrs)');



subplot(2,2,2);
plot(var_temps,180/pi*var_lacet,'g');
title('LACET (en degrs)');



subplot(2,2,3);
plot(var_temps,180/pi*var_tangage,'g');
title('TANGAGE (en degrs)');


figure(gcf)

% subplot(1,1,1);

figure(2)
subplot(2,2,1);
var_roulis=2*var_roulis;
var_roulis=unwrap(var_roulis); 
var_roulis=0.5*var_roulis;     	
plot(var_temps,180/pi*var_roulis,'r');
title('ROULIS (en degrs)');

subplot(2,2,2);
var_lacet=2*var_lacet;
var_lacet=unwrap(var_lacet);
var_lacet=0.5*var_lacet;
plot(var_temps,180/pi*var_lacet,'g');
title('LACET (en degrs)');

subplot(2,2,3);
var_tangage=2*var_tangage;
var_tangage=unwrap(var_tangage);
var_tangage=0.5*var_tangage;
plot(var_temps,180/pi*var_tangage,'g');
title('TANGAGE (en degrs)');

figure(3)
subplot(1,1,1)
plot3(x_3d(1),y_3d(1),z_3d(1),'*')
hold on
plot3(x_3d,y_3d,z_3d)