function y=der_sys(u);


% ************************************************
% Le vecteur d'entre u est  10 composantes
%
%	u(1)=p    rotation absolue satellite sur x
%	u(2)=q    ...........................sur y
%	u(3)=r    ...........................sur z
%
%	u(4)=q0   Premire composante du quaternion
%	u(5)=q1   Deuxime ........................
%	u(6)=q2   Troisime .......................
%	u(7)=q3   Quatrime .......................
%
% Les donnes inertielles
%	u(8)=Ir   Inertie roulis
%       u(9)=It   ....... tangage
%	u(10)=Il  ....... lacet
%
% Dans le bloc diagramme nous multiplexerons ces entres
%  7+3=10
%
% ******************************************************

p=u(1);q=u(2);r=u(3);
% normalisation du quaternion d'entre
v=u(4:7)/norm(u(4:7));
q0=v(1);q1=v(2);q2=v(3);q3=v(4);
Ir=u(8);It=u(9);Il=u(10);

y=[];

% Calcul des drives de p q r

y(1)=(Il-It)/Ir*(-q*r);
y(2)=(Ir-Il)/It*(-p*r);
y(3)=(It-Ir)/Il*(-q*p);

% Matrice W* de rotation relative en temps que quaternion

Matrice_rotation=[0 -p -q -r
                 p 0 r -q
		 q -r 0 p
		 r q -p 0];

z=0.5*Matrice_rotation*[q0 q1 q2 q3]';

y=[y z']';

end
